/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F18326
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.36 and above
        MPLAB 	          :  MPLAB X 6.00	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set Set aliases
#define Set_TRIS                 TRISAbits.TRISA2
#define Set_LAT                  LATAbits.LATA2
#define Set_PORT                 PORTAbits.RA2
#define Set_WPU                  WPUAbits.WPUA2
#define Set_OD                   ODCONAbits.ODCA2
#define Set_ANS                  ANSELAbits.ANSA2
#define Set_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define Set_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define Set_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define Set_GetValue()           PORTAbits.RA2
#define Set_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define Set_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define Set_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define Set_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define Set_SetPushPull()        do { ODCONAbits.ODCA2 = 0; } while(0)
#define Set_SetOpenDrain()       do { ODCONAbits.ODCA2 = 1; } while(0)
#define Set_SetAnalogMode()      do { ANSELAbits.ANSA2 = 1; } while(0)
#define Set_SetDigitalMode()     do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set LED1 aliases
#define LED1_TRIS                 TRISAbits.TRISA4
#define LED1_LAT                  LATAbits.LATA4
#define LED1_PORT                 PORTAbits.RA4
#define LED1_WPU                  WPUAbits.WPUA4
#define LED1_OD                   ODCONAbits.ODCA4
#define LED1_ANS                  ANSELAbits.ANSA4
#define LED1_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define LED1_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define LED1_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define LED1_GetValue()           PORTAbits.RA4
#define LED1_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define LED1_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define LED1_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define LED1_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define LED1_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define LED1_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define LED1_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define LED1_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set LED2 aliases
#define LED2_TRIS                 TRISAbits.TRISA5
#define LED2_LAT                  LATAbits.LATA5
#define LED2_PORT                 PORTAbits.RA5
#define LED2_WPU                  WPUAbits.WPUA5
#define LED2_OD                   ODCONAbits.ODCA5
#define LED2_ANS                  ANSELAbits.ANSA5
#define LED2_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define LED2_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define LED2_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define LED2_GetValue()           PORTAbits.RA5
#define LED2_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define LED2_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define LED2_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define LED2_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define LED2_SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define LED2_SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define LED2_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define LED2_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set Up aliases
#define Up_TRIS                 TRISCbits.TRISC0
#define Up_LAT                  LATCbits.LATC0
#define Up_PORT                 PORTCbits.RC0
#define Up_WPU                  WPUCbits.WPUC0
#define Up_OD                   ODCONCbits.ODCC0
#define Up_ANS                  ANSELCbits.ANSC0
#define Up_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define Up_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define Up_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define Up_GetValue()           PORTCbits.RC0
#define Up_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define Up_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define Up_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define Up_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define Up_SetPushPull()        do { ODCONCbits.ODCC0 = 0; } while(0)
#define Up_SetOpenDrain()       do { ODCONCbits.ODCC0 = 1; } while(0)
#define Up_SetAnalogMode()      do { ANSELCbits.ANSC0 = 1; } while(0)
#define Up_SetDigitalMode()     do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set Down aliases
#define Down_TRIS                 TRISCbits.TRISC1
#define Down_LAT                  LATCbits.LATC1
#define Down_PORT                 PORTCbits.RC1
#define Down_WPU                  WPUCbits.WPUC1
#define Down_OD                   ODCONCbits.ODCC1
#define Down_ANS                  ANSELCbits.ANSC1
#define Down_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define Down_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define Down_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define Down_GetValue()           PORTCbits.RC1
#define Down_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define Down_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define Down_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define Down_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define Down_SetPushPull()        do { ODCONCbits.ODCC1 = 0; } while(0)
#define Down_SetOpenDrain()       do { ODCONCbits.ODCC1 = 1; } while(0)
#define Down_SetAnalogMode()      do { ANSELCbits.ANSC1 = 1; } while(0)
#define Down_SetDigitalMode()     do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set Clock aliases
#define Clock_TRIS                 TRISCbits.TRISC2
#define Clock_LAT                  LATCbits.LATC2
#define Clock_PORT                 PORTCbits.RC2
#define Clock_WPU                  WPUCbits.WPUC2
#define Clock_OD                   ODCONCbits.ODCC2
#define Clock_ANS                  ANSELCbits.ANSC2
#define Clock_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define Clock_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define Clock_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define Clock_GetValue()           PORTCbits.RC2
#define Clock_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define Clock_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define Clock_SetPullup()          do { WPUCbits.WPUC2 = 1; } while(0)
#define Clock_ResetPullup()        do { WPUCbits.WPUC2 = 0; } while(0)
#define Clock_SetPushPull()        do { ODCONCbits.ODCC2 = 0; } while(0)
#define Clock_SetOpenDrain()       do { ODCONCbits.ODCC2 = 1; } while(0)
#define Clock_SetAnalogMode()      do { ANSELCbits.ANSC2 = 1; } while(0)
#define Clock_SetDigitalMode()     do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set RC3 procedures
#define RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define RC3_GetValue()              PORTCbits.RC3
#define RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define RC3_SetPullup()             do { WPUCbits.WPUC3 = 1; } while(0)
#define RC3_ResetPullup()           do { WPUCbits.WPUC3 = 0; } while(0)
#define RC3_SetAnalogMode()         do { ANSELCbits.ANSC3 = 1; } while(0)
#define RC3_SetDigitalMode()        do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set RC4 procedures
#define RC4_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define RC4_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define RC4_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define RC4_GetValue()              PORTCbits.RC4
#define RC4_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define RC4_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define RC4_SetPullup()             do { WPUCbits.WPUC4 = 1; } while(0)
#define RC4_ResetPullup()           do { WPUCbits.WPUC4 = 0; } while(0)
#define RC4_SetAnalogMode()         do { ANSELCbits.ANSC4 = 1; } while(0)
#define RC4_SetDigitalMode()        do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set RC5 procedures
#define RC5_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define RC5_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define RC5_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define RC5_GetValue()              PORTCbits.RC5
#define RC5_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define RC5_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define RC5_SetPullup()             do { WPUCbits.WPUC5 = 1; } while(0)
#define RC5_ResetPullup()           do { WPUCbits.WPUC5 = 0; } while(0)
#define RC5_SetAnalogMode()         do { ANSELCbits.ANSC5 = 1; } while(0)
#define RC5_SetDigitalMode()        do { ANSELCbits.ANSC5 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/