/************************************************
 *  DSP Radio Control Program
 *   KT0913  + PIC16F18326  @\
 * @ǃXgŃAbv_E v@\ǉ
 **********************************************/
#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"
#include "Radio.h"
// ϐ`
uint8_t Flag, Index;
char Line1[17], Line2[17];
uint16_t CH, SetFreq;
int16_t RSSI;
uint8_t sec, min, hour, alhour, almin, pos, SbyFlag;
double Freq;
// t\@RgXgp萔
//#define CONTRAST  0x18            // for 5.0V
#define CONTRAST  0x25              // for 3.3V
#define MAX 16                      // ǃXgől
// ֐vg
void UpDown(void);
void Disp(void);
void Setting(void);
void SetReg(uint8_t reg, uint16_t data);
void DSP_Init(void);
void lcd_data(char data);
void lcd_cmd(char cmd);
void lcd_init(void);
void lcd_str(char* ptr);
/***********************************
 * ^C}0 Callback֐@1b
 ***********************************/
void TMR0_Process(void){
    Flag = 1;                                       // tOZbg
}
/***********************************
 * ^C}1 Callback֐@1b
 *  JEgAbv
 ***********************************/
void TMR1_Process(void){
    sec++;                                          // bAbv
    if(sec >= 60){                                  // 60bȂ
        sec = 0;                                    // 0ɖ߂
        min++;                                      // Abv         
        if((hour == alhour) && (min == almin)){     // A[v̏ꍇ
             SetReg(0x0F, 0x881C);                  // Standby Mode 
             SbyFlag = 0;                           // X^hoC
             LED1_SetLow();                        // ڈ
        }     
        if(min >= 60){                              // 60Ȃ
            min = 0;                                // 0ɖ߂
            hour++;                                 // Abv
            if(hour >= 24){                         // 24Ȃ
                hour = 0;                           // 0ɖ߂
            }
        }
    }
}
/********* C֐ *************************/
void main(void){
    SYSTEM_Initialize();                            // VXe
    lcd_init();                                     // t\평
    // 荞Callback֐`
    TMR0_SetInterruptHandler(TMR0_Process);
    TMR1_SetInterruptHandler(TMR1_Process);
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    // KT0913 Initial Setting
    __delay_ms(1000);                               // NbNU҂
    DSP_Init();                                     // FM/AMݒ
    Disp();                                         // g\
    /**** C[v **************/
    while (1) {
        if(Clock_GetValue() == 0){                  // CLOCKXCb``FbN
            /*********** ǑI[h@*********/
            UpDown();                               // ǃAbv_E
            // A[pX^oCݒ
            if(Set_GetValue() == 0){                // SetXCb``FbN
                if(SbyFlag == 0){       // ܂X^oC[hłȂꍇ
                    SbyFlag = 1;                    // X^oC[htOZbg
                    Disp();                         // \XV
                    LED1_SetHigh();                 // ڈ_
                    SetReg(0x0F, 0x981C);           // X^hoCɃZbg                     
                }
                else{                   // ɃX^oC[h̏ꍇ
                    SbyFlag = 0;                    // X^oC[h
                    Disp();                         // \XV
                    LED1_SetLow();
                    SetReg(0x0F, 0x881C);           // Standby Mode                    
                }
                while(Set_GetValue() == 0);         // `b^O
                __delay_ms(100);                 
            }
        }
        else{
            /********* ݒ胂[h **************/
            if(Set_GetValue() == 0){                // ݒJn{^I               
                INTERRUPT_GlobalInterruptDisable(); // 荞݋֎~@v~
                lcd_cmd(0x80);                      // 1sڎw
                lcd_cmd(0x0F);                      // uNw
                __delay_ms(100);                    // `b^
                while(Set_GetValue() == 0);
                __delay_ms(100);
                /***** ݒ **********/              
                Setting();                          // eݒ胋[v
                lcd_cmd(0xC0);                      // 2sڎw
                lcd_str("Setting Complete");        // bZ[W
                __delay_ms(2000);                   // 2bԕ\
                // EEPROMɕۑ
                DATAEE_WriteByte(0xF002, hour);
                DATAEE_WriteByte(0xF003, min);  
                DATAEE_WriteByte(0xF004, sec);
                DATAEE_WriteByte(0xF005, alhour);  
                DATAEE_WriteByte(0xF006, almin);
                INTERRUPT_GlobalInterruptEnable();   // 荞ݍċ
            }
        }
        // 1bƂ̊荞݂ŎMx\XV
        if(Flag == 1){                              // 1b
            Flag = 0;
            Disp();                                 // \s
        }
    }
}
/**************@Tu֐@*******************/
/************************************
 * KT0913ݒ
 *  FM݂̂̐ݒ
 ***********************************/
void DSP_Init(void){
    // lEEPROMǂݏo
    hour = DATAEE_ReadByte(0xF002);                 // 
    min = DATAEE_ReadByte(0xF003);                  // 
    sec = DATAEE_ReadByte(0xF004);                  // b
    alhour = DATAEE_ReadByte(0xF005);               // A[
    almin = DATAEE_ReadByte(0xF006);                // A[   
    // WIǐݒ@EEPROMǂݏo
    Index = DATAEE_ReadByte(0xF001);                // 0xF001Ԓnǂݏo
    SetFreq = (uint16_t)((FMstation[Index].freq) / 0.05);    
    SetReg(0x16, 0x0902);                           // Clock 38kHz
    SetReg(0x03, SetFreq | 0x8000);                 // FM Tune Trigger 81.3MHz
    SetReg(0x04, 0xE180);                           // Mute Disable Bass Low
    SetReg(0x0A, 0x0000);                           // AFC Enable
    SetReg(0x05, 0x1800);                           // Stereo 50us
    SetReg(0x0F, 0x881C);                           // Volume -6dB
    SbyFlag = 0;                                    // X^oCtOZbg
    Disp();
}
/*************************************
 * gAMxt\Tu
 *************************************/
void Disp(void){
    if(Clock_GetValue() == 0){
        if(SbyFlag == 0){
            sprintf(Line1, "%s", FMstation[Index].name);        //ǖ\                
            CH = I2C1_Read2ByteRegister(0x35, 0x03);            // `lg擾 
            Freq = (CH & 0x0FFF) * 0.050;                       // gɕϊ    
            // Mx\    dBmɕϊ
            RSSI = (I2C1_Read2ByteRegister(0x35, 0x12) & 0x00F8) >> 3; 
            RSSI = -100 + RSSI * 3;
            sprintf(Line2, "%2.1fMHz  %3ddBm ", Freq, RSSI);     
        }
        else{
            sprintf(Line2, "***Sandby Mode***");            // X^hoCƎ\
            sprintf(Line1, "%02d:%02d:%02d  A%02d:%02d", hour, min, sec, alhour, almin);             
        }
    }
    else{
        // \
        sprintf(Line1, "%02d:%02d:%02d  A%02d:%02d", hour, min, sec, alhour, almin);
        //ǖ\
        sprintf(Line2, "%s", FMstation[Index].name);
    }
    lcd_cmd(0x80);                  // 1s
    lcd_str(Line1);
    lcd_cmd(0xC0);                  // 2s
    lcd_str(Line2);         
}
/*******************************
 * ǃAbv_ETu֐
 *******************************/
void UpDown(void){
    // ǃXgAbv̏ꍇ
    if(Up_GetValue() == 0){                         // AbvXCb`Ȉꍇ
        __delay_ms(100);                            // `b^
        Index++;                                    // CfbNXAbv
        if(Index >= MAX)                            // ŌɂȂ
            Index = 0;                              // ŏɖ߂
        SetFreq = (uint16_t)((FMstation[Index].freq) / 0.05);
        SetReg(0x03, SetFreq | 0x8000);             // gݒ
        Disp();                                     // LCD\XV
        DATAEE_WriteByte(0xF001, Index);            // 0xF001Ԓnɕۑ 
        while(Up_GetValue() == 0);                  // Ăԑ҂            
        __delay_ms(100);                            // `b^            
    }
    // ǃXg_Ȅꍇ
    if(Down_GetValue() == 0){                       // _EXCb`Ȉꍇ
        __delay_ms(100);                            // `b^             
        if(Index > 0)                               // ŏłȂ
            Index--;                                // CfbNX_E
        else                                        // ŏ
            Index = MAX-1;                          // Ōɖ߂
        SetFreq = (uint16_t)((FMstation[Index].freq) / 0.05);
        SetReg(0x03, SetFreq | 0x8000);             // gݒ
        Disp();                                     // \XV
        DATAEE_WriteByte(0xF001, Index);            // 0xF001Ԓnɕۑ 
        while(Down_GetValue() == 0);                // Ăԑ҂             
        __delay_ms(100);                            // `b^          
    }    
}
/*******************************
 * ݒTu֐
 *******************************/
void Setting(void){
    pos = 0;                                        // ݒ莞Ԉʒu 
    while(pos < 5){                                 // SڌJԂ
        if(Up_GetValue() == 0){                     // AbvSWȈꍇ  
            __delay_ms(300);
            switch(pos){                            // ڂƂɃAbv
                case 0: hour++; if(hour>23) hour=0 ;break;
                case 1: min++; if(min>59) min=0; break;
                case 2: sec++; if(sec>59) sec=0; break;
                case 3: alhour++; if(alhour>23) alhour=0; break;
                case 4: almin++; if(almin>59) almin=0; break;
                default:break;
            }
            Disp();                                 // \XV
        }
        if(Down_GetValue() == 0){                   // _ESWȈꍇ
            __delay_ms(300);
            switch(pos){                            // ڕʂ-1
                case 0: hour--; if(hour==0xFF) hour= 23; break;
                case 1: min--; if(min==0xFF) min=59; break;
                case 2: sec--; if(sec==0xFF) sec=59; break;
                case 3: alhour--; if(alhour==0xFF) alhour=23; break;
                case 4: almin--; if(almin==0xFF) almin=59; break;
                default: break;
            }
            Disp();                                 // \XV
        }
        if(Set_GetValue() == 0){                    // ZbgSWȈꍇ
            __delay_ms(100);                        // `b^
            pos++;                                  // ̍ڂ
            switch(pos){                            // ڂƂBlink
                case 0: lcd_cmd(0x81); break;
                case 1: lcd_cmd(0x83); break;
                case 2: lcd_cmd(0x86); break;
                case 3: lcd_cmd(0x8B); break;
                case 4: lcd_cmd(0x8E); break;
                default: break;
            }
            lcd_cmd(0x0F);                          // blink
            while(Set_GetValue() == 0);
            __delay_ms(100);
        }
    }    
}
/*********************************
 * KT0913@2oCgo͐Tu
 ********************************/
void SetReg(uint8_t reg, uint16_t data){
    uint16_t temp;
    
    temp = data << 8;                   // ʉʓւ
    temp = temp | ((data >> 8) & 0xFF);
    I2C1_Write2ByteRegister(0x35, reg, temp);
}
/*********************************
* t1\f[^o
*********************************/
void lcd_data(char data){
    I2C1_Write1ByteRegister(0x3E, 0x40, data); 
    __delay_us(30);                     // ҂x
}
/*******************************
* tւPR}ho
*******************************/
void lcd_cmd(char cmd){
    I2C1_Write1ByteRegister(0x3E, 0x00, cmd);
    /* ClearHomêƂx */
    if((cmd == 0x01)||(cmd == 0x02))
        __delay_ms(2);                  // 2msec҂
    else
        __delay_us(30);                 // 30sec҂
}
/*******************************
*  t\@֐
*******************************/
void lcd_init(void){
    __delay_ms(150);                    // n[h҂
    lcd_cmd(0x38);                      // 8bit 2line Normal mode
    lcd_cmd(0x39);                      // 8bit 2line Extend mode
    lcd_cmd(0x14);                      // OSC 183Hz BIAS 1/5
    /* RgXgݒ */
    lcd_cmd(0x70 + (CONTRAST & 0x0F));
    lcd_cmd(0x5C + (CONTRAST >> 4));
//    lcd_cmd(0x6B);                    // Follower for 5.0V
    lcd_cmd(0x6B);                      // Follwer for 3.3V
    __delay_ms(300);
    lcd_cmd(0x38);                      // Set Normal mode
    lcd_cmd(0x0C);                      // Display On
    lcd_cmd(0x01);                      // Clear Display
}
/*****************************
* t\@\֐
*****************************/
void lcd_str(char* ptr){
    while(*ptr != 0)                    // Ō܂
        lcd_data(*ptr++);               // \s
}
